/* adc_int

   Folyamatos módban mérünk az ADC-vel, a konverziók végén
   programmegszakítást kérünk, s az ADC megszakításkiszolgáló
   eljárásban olvassuk ki az eredményt.
   Az ADC-vel itt az A0 bemenetre kapcsolt feszültséget mérjük
   A nyers eredményeket a soros porton kiíratjuk.
*/

volatile int value = 0;    // analog value
volatile int eoc = 0;      // End of conversion jelző

void setup() {
  Serial.begin(115200);
  //--- ADC indítás megszakításos módban ---
  DIDR0 = 0x3F;            // digital inputs disabled
  ADMUX = _BV(REFS0);      // Mérés az A0 csatornában, 5V referenciával
  ADCSRA = _BV(ADEN) |     // ADC enable
           _BV(ADATE)|     // auto trigger enable
           _BV(ADIE) |     // interrupt enable
           _BV(ADPS2);     // prescaler = 16  (azaz 2^4)
  ADCSRB = 0x00;           // AD channels MUX off, free running mode
  ADCSRA |= _BV(ADSC);     // Konverzió indítása
  sei();                   // megszakítás globális engedélyezése
}

void loop() {
  if (eoc) {
    eoc = 0;
    Serial.println(value);
  }
}

//--- 'ADC kész' megszakítás kiszolgálása ---
ISR(ADC_vect) {
  value = ADCL;             // eredmány alsó bájt
  value += ADCH << 8;       // eredmény felső bitek
  eoc = 1;
}
